# Garden User Guide

## Introduction

Garden streamlines development workflows that involve a loosely-coupled set of
multiple, independent Git trees.

Garden allows you to define dynamic relationships and workflows between these
repositories using a YAML configuration file that can be shared and used as
a bootstrapping mechanism for getting an audit-able, from-source project cloned,
built, installed and running with minimal effort for consumers of a Garden file.

Garden sits above any individual project's build scripts and conventions.
Garden is all about making it easy to remix and reuse libraries maintained
in separate Git repositories.

### Project Links

* [Garden source code repository](https://gitlab.com/garden-rs/garden)

* [Garden crates.io package](https://crates.io/crates/garden-tools)

* [Garden Homebrew formula](https://gitlab.com/garden-rs/homebrew-garden)

* [Garden NetBSD pkgsrc](https://cdn.netbsd.org/pub/pkgsrc/current/pkgsrc/devel/garden/index.html)

* [Garden API Documentation](https://docs.rs/garden-tools)
